#include "treeeditor.h"

#include <QAction>
#include <QRegExp>

#include "vymmodel.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
TreeEditor::TreeEditor(VymModel *m)
{
	model=m;

	// FIXME-3 use proxmodel
	//proxyModel = new MySortFilterProxyModel(this);	
	//setModel(proxyModel);
	setModel(m);
	//proxyModel->setSourceModel(model);

	QAction *a;
	// Shortcuts for navigating with cursor:
    a = new QAction(tr( "Select upper object","Tree Editor" ), this);
	a->setStatusTip ( tr( "Select upper object" ));
	a->setShortcut (Qt::Key_Up );
	a->setShortcutContext (Qt::WidgetShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorUp() ) );

    a = new QAction( tr( "Select lower object","Tree Editor" ),this);
	a->setStatusTip (tr( "Select lower object" ));
	a->setShortcut ( Qt::Key_Down );
	a->setShortcutContext (Qt::WidgetShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorDown() ) );
}

TreeEditor::~TreeEditor()
{
	//cout <<"Destructor TreeEditor for "<<model->getMapName().toStdString()<<endl;
}

MySortFilterProxyModel* TreeEditor::getProxyModel()
{
	return proxyModel;
}

QModelIndex TreeEditor::getSelectedIndex()
{
	QModelIndexList list=selectionModel()->selectedIndexes();
	if (list.isEmpty() )
		return QModelIndex();
	else
		return list.first();
}


void TreeEditor::setSortFilter(QString s)
{
	proxyModel->setFilterRegExp(QRegExp(s, Qt::CaseInsensitive));
	proxyModel->setFilterKeyColumn(0);
	proxyModel->setDynamicSortFilter (true);
}

void TreeEditor::cursorUp()
{
	QModelIndex ix=getSelectedIndex();
	// FIXME-3 useproxymodel ix=proxyModel->mapToSource (indexAbove(ix));
	ix=indexAbove (ix);
	if (ix.isValid())
		model->select (ix );
}

void TreeEditor::cursorDown()
{
	QModelIndex ix=getSelectedIndex();
	//FIXME-3 useProxymodel ix=proxyModel->mapToSource (indexBelow(ix));
	ix=indexBelow (ix);
	if (ix.isValid())
		model->select (ix );
}

